rand('seed', getdate('s'))
rand('uniform')

function y=simul1_binomiale(n,p)
    // version itérative
    y=0;
    for k=1:n
        if (rand()<p) then y=y+1;
        end
    end
endfunction

function y=simul2_binomiale(n,p)
    // version matricielle
    U=rand(1,n)
    y=sum(U<p);
endfunction

function y=distrib_binomiale(n,p)
    y=zeros(1,n+1);
    // ci-dessous on met à jour le vecteur y pour que y(k) contienne P(X=k-1) pour 1<=k<=n+1
    y(1)=(1-p)^n;
    for k=1:n
        // P(X=k)=(n-k+1)/k*p/(1-p)*P(X=k-1)
        y(k+1)=(n-k+1)/k*p/(1-p)*y(k);
    end
endfunction

n=15;       // choix des paramètres
p=.25;      // choix des paramètres
S=0:n;      // vecteur des valeurs possibles pour X
N=10^5;     // nombre de simulations

// Version classique : 
// X=zeros(1,N);    // initialisation du vecteur des résultats
// for k=1:N
//    X(k)=simul_binomiale(n,p);
// end

// Version matricielle : 
U=rand(N,n);
X=sum(U<p,'c');

[I,y_stat]=dsearch(X,S,'d');
y_stat=y_stat/N;

y_th=distrib_binomiale(n,p)

clf;
subplot(121)
    bar(S,y_stat);
subplot(122)
    bar(S,y_th);
