rand('seed', getdate('s'))
rand('uniform')

function y=simul_geometrique(p)
  y=1;
  while (rand()>p)
    y=y+1;
  end
endfunction

function y=distrib_geometrique(p,n)
    y=cumprod((1-p)*ones(1,n))*p/(1-p);
endfunction

p=.25;      // choix du paramètre
n=15;       // abscisse maximale pour le diagramme
S=1:n;      // vecteur des valeurs possibles pour X
N=10^5;     // nombre de simulations

X=zeros(1,N);   // initiatlisation du vecteur des résultats des simulations
for k=1:N
    X(k)=simul_geometrique(p);
end
[I,y_stat]=dsearch(X,S,'d');
y_stat=y_stat/N;

y_th=distrib_geometrique(p,n);

clf;
subplot(121)
    bar(S,y_stat);
subplot(122)
    bar(S,y_th);
