rand('seed', getdate('s'))
rand('uniform')

function y=simul_poisson(lambda)
    u=rand();
    y=0;
    p=exp(-lambda); // p=p(y)
    F=p;            // F=F(y)
    while (u>F)
        // p=p(y) F=F(y)
        // lors du dernier passage ICI, F(y)<u<=F(y+1)
        //      -> on veut renvoyer y+1
        y=y+1;
        p=lambda/y*p;   // MAJ p
        F=F+p;          // MAJ F
    end
endfunction

function Y=simul_mult_poisson(n,lambda)
    // simule n variables aléatoires indépendantes de Poisson
    U=rand(1,n);
    Y=-ones(1,n);
    k=0;
    p=exp(-lambda);
    F=p;
    while (sum(Y==-1)>0)
        Y(find((Y==-1)&(U<=F)))=k;
        k=k+1;
        p=p*lambda/k;
        F=F+p;
    end
endfunction

function y=distrib_poisson(lambda,n)
    y=exp(-lambda)*[1 cumprod(lambda./(1:n))];
endfunction

lambda=5;   // choix du paramètre
n=15;       // abscisse maximale pour le diagramme
S=0:n;      // vecteur des valeurs possibles pour X
N=10^5;     // nombre de simulations

X=simul_mult_poisson(N,lambda);
[I,y_stat]=dsearch(X,S,'d');
y_stat=y_stat/N;

y_th=distrib_poisson(lambda,n);

clf;
subplot(121)
    bar(S,y_stat);
subplot(122)
    bar(S,y_th);
